def inBoundary(M,i,j):
    if (0 <= i < len(M)) and ( 0 <= j < len(M[0]) ) :
        return True
    return False
    
def checkRight(M,i,j):
    if inBoundary(M,i,j+2) and (M[i][j] == M[i][j+1] == M[i][j+2] ):
        return True
    return False
        
def checkDown(M,i,j):
    if inBoundary(M,i+2,j) and (M[i][j] == M[i+1][j] == M[i+2][j]) :
        return True
    return False

def checkRDiagonal(M,i,j):
    if inBoundary(M,i+2,j+2) and (M[i][j] == M[i+1][j+1] == M[i+2][j+2]) :
        return True
    return False

def checkLDiagonal(M,i,j):
    if inBoundary(M,i+2,j-2) and (M[i][j] == M[i+1][j-1] == M[i+2][j-2]) :
        return True
    return False

def checkContinue(M) :
    for i in range (len(M)):
        for j in range (len(M[0])):
            #print(i,j, end="   ")
            if(checkRight(M,i,j) or checkDown(M,i,j) or checkRDiagonal(M,i,j) or checkLDiagonal(M,i,j)) :
                return True
    return False

print ( checkContinue( [ [1,1,1,2],[5,6,3,3],[6,5,4,4],[8,2,2,1] ] ) )  
print ( checkContinue( [ [3,5,6,7],[2,3,7,5],[8,3,3,4],[9,0,8,3] ] ) )  
print ( checkContinue( [ [1,4,1,2],[5,4,3,3],[6,4,4,5],[8,2,2,1] ] ) )  
print ( checkContinue( [ [3,5,6,7],[2,1,7,5],[8,7,3,4],[9,0,8,3] ] ) )  
print ( checkContinue( [ [1,2,3,4],[1,2,5,6],[7,8,9,0],[1,2,9,0] ] ) )
