from turtle import *    
import random

scr = Screen()
scr.setup(800, 800 ) 
scr.colormode(255)  # RGB 칼라를 사용하기 위해서 255로 설정 
t = Turtle("turtle")  

def draw_polygon(n,s):  # 한변의 size가 s인  n각형 만드는 함수
    for i in range(n):
        t.forward(s)
        t.left(360/n)     

for i in range(10) :   # 다각형의 시작 위치와 몇각형인지, 길이는 얼마인지, 
                       #색의 (R,G,B) 값은 얼마인지 랜덤으로 결정하고 그려주기 반복
    x = random.randint( -300,300 )  # 다각형 시작점의 x좌표
    y = random.randint( -300,300 )  # 다각형 시작점의 y좌표
    n = random.randint( 3,10 )      # 정 N 각형을 생성
    s = random.randint( 10,40 )     # 다각형 한변의 길이 설정
    r,g,b = random.randint(0,255),random.randint(0,255),random.randint(0,255)  # 색깔 결정

    t.penup()    
    t.goto (x,y)  # 생성된 임의의 x,y 좌표로 이동
    t.pendown()  
    t.color((r,g,b))
    t.begin_fill ()         # 다각형을 그린후 내부를 채우겠다고 표시
    draw_polygon(n,s)    # 다각형 그리기 서브 함수 호출
    t.end_fill()

t.penup()  # 모든 작업을 끝내고 (0,0)으로 거북이 이동
t.goto (0,0)
t.pendown()  
