from turtle import * 
def interpolate (t , color1, color2) :  # 두개의 색을 보간하는 함수
    r1,g1,b1 = color1
    r2,g2,b2 = color2
    return (int ((1-t)*r1 + t*r2), int ((1-t)*g1 + t*g2), int ((1-t)*b1 + t*b2))

scr = Screen()
scr.setup(1400 , 400 )   
colormode(255)
t = Turtle()             
t.shape("circle")
t.left(90)
x, y = -700 ,100
move = -200
color_array = [(255,0,0),(255,97,3),(255,255,0),(0,128,0),(0,0,255),(75,0,130),(238,130,238)] 
            # 빨주노초파남보
t.penup()
t.goto (x,y)
t.pendown()  

for c in range (6):   # 7가지 무지개색에 대해 두가지 색을 선택하여 반복
    color1 =  color_array [c]
    color2 =  color_array [c+1]
    for i in range(100):  # 100단계로 색깔을 그라데이션 한다
        a = i/100
        (r,g,b) = interpolate (a , color1, color2)
        move  *= -1             # 아래와 위로 한번씩 방향을 바꿈 
        t.color((r,g,b))
        t.goto (t.xcor()+1,t.ycor())  # x 축으로 한칸씩 옮기기
        t.forward(move)          # y 축으로 move 크기만큼 이동
t.hideturtle()
done()                  # 에디터에 따라 실행후 스크린이 사리지는 것을 방지  
