def topView(P):
    assert len(P) == len(P[0]) == len(P[0][0])
    n = len(P)
    V = [ [0]*n  for i in range(n) ]
    for j in range(n):
        for k in range(n):
            for i in range(n):
                if P[i][j][k] == 1:
                    V[j][k] = 1
                    break
    return V

    
def frontView(P):
    assert len(P) == len(P[0]) == len(P[0][0])
    n = len(P)
    V = [ [0]*n  for i in range(n) ]
    for i in range(n):
        for k in range(n):
            for j in range(n):
                if P[i][j][k] == 1:
                    V[i][k] = 1
                    break
    return V

    
def rightView(P):
    assert len(P) == len(P[0]) == len(P[0][0])
    n = len(P)
    V = [ [0]*n  for i in range(n) ]
    for i in range(n):
        for j in range(n):
            for k in range(n):
                if P[i][j][k] == 1:
                    V[i][j] = 1
                    break
    return V


def test() :
    P1 = [ [ [0,0,0],
             [0,0,0],
             [1,0,0] ] ,
           [ [1,0,1],
             [0,0,0],
             [1,0,1] ] ,
           [ [1,0,1],
             [1,1,1],
             [1,1,1] ] ]
    print(topView(P1))   # [[1,0,1], [1,1,1], [1,1,1]]
    print(frontView(P1)) # [[1,0,0], [1,0,1], [1,1,1]]
    print(rightView(P1)) # [[0,0,1], [1,0,1], [1,1,1]]
    
    
    P2 = [ [ [1,0,0],
             [0,0,0],
             [1,0,0] ] ,
           [ [0,0,1],
             [1,1,0],
             [1,0,1] ] ,
           [ [0,1,0],
             [0,0,0],
             [1,0,0] ] ]
    print(topView(P2))   # [[1,1,1], [1,1,0], [1,0,1]]
    print(frontView(P2)) # [[1,0,0], [1,1,1], [1,1,0]]
    print(rightView(P2)) # [[1,0,1], [1,1,1], [1,0,1]]
    
    
if __name__ == '__main__': test() 