from Chap19_L01 import *

##################################################################
def countCubes(top, front, right):
    assert len(top)==len(top[0])==len(front)==len(front[0])==len(right)==len(right[0])
    n = len(top)

    count = 0
    P = [ [ [None]*n  for i in range(n) ] for j in range(n) ]

    for i in range(n):
        for j in range(n):
            for k in range(n):
                # (i,j,k) -> top[j][k], front[i][k], right[i][j]
                if top[j][k] == front[i][k] == right[i][j] == 1:
                    P[i][j][k] = 1
                    count += 1
                else:
                    P[i][j][k] = 0

    # check feasibility for each view
    if top == topView(P) and front == frontView(P) and right == rightView(P):
        return count
    else:
        return None
    
    
top   =  [[1,0,1], [1,1,1], [1,1,1]] 
front =  [[1,0,0], [1,0,1], [1,1,1]]
right =  [[0,0,1], [1,0,1], [1,1,1]]

 
 
print (countCubes(top, front, right))   #13
    
    