def average(M):
    n = len(M)
    total = 0
    for i in range(n):
        total += M[i]
    return total/n

def standardDeviation(M):
    ave = average(M)
    n = len(M)
    total = 0
    for i in range(n):
        total += (M[i]-ave)**2
    return (total/n)**0.5

def countWithinRange(L):
    n = len(L)
    M = [None]*n
    for i in range(n):
        M[i] = L[i]**3

    ave = average(M)
    sigma = standardDeviation(M)

    #print (ave,sigma)      # 중간 확인용 print 구문은 나중에 주석으로 막는다.
    counter = 0
    for i in range(n):
        if ave-sigma <= M[i] <= ave+sigma:
            counter += 1
    return counter
        
print(countWithinRange([2,3,4,7,8,9,13,14,15]))  # 7  
print(countWithinRange([11,12,13,14,15]))  # 3
